#version 330 core

layout (location = 0) in vec3 aPositionVertex;
in vec3 aNormal;
in vec2 aUV;
in vec3 aTangent;
in vec4 aBoneWeights;
in ivec4 aBoneIDs;

out vec4 vFinalVertexColor;
out vec3 vWorldNormal;
out vec2 vUVs;
//out vec3 vTangent;

//varyings
out vec3 varNormal;
out vec3 varVertexPosition;
out vec3 varTangent;

uniform mat4 projectionMatrix;
uniform mat4 viewMatrix;
uniform mat4 modelMatrix;

const int MAX_BONES = 100;
uniform mat4 boneTransforms[MAX_BONES];
uniform int hasBones;

void main(){

	mat4 boneMatrix = mat4(1.0);

	if ((hasBones == 1) && (aBoneIDs[0] != -1)){
		boneMatrix = mat4(0.0);
		for (int i=0; i<4; i++){
			if ((aBoneIDs[i] != -1)){
				boneMatrix += boneTransforms[aBoneIDs[i]] * aBoneWeights[i];
			}
		}
	}

	// RIGHT CODE
	/*
	if ((hasBones == 1) && (aBoneIDs[0] != -1)){
		boneMatrix = mat4(0.0);
		//boneMatrix += boneTransforms[aBoneIDs[0]];
		for (int i=0; i<4; i++){
			if ((aBoneIDs[i] != -1)&&(aBoneWeights[i] >= 0)&&(aBoneWeights[i] <= 1)){
				boneMatrix += boneTransforms[aBoneIDs[i]] * aBoneWeights[i];
			}
		}
	}
	*/
	vUVs = aUV;
	vWorldNormal = (modelMatrix * boneMatrix * vec4(aNormal, 0)).xyz;

	// TODO modelViewMatrix can be precomputed! (view * model)
	//mat4 viewMatrix = mat4(1);


	//vec4 vertPos4 = viewMatrix * modelMatrix * vec4(aPositionVertex, 1);
	vec4 vertPos4 = modelMatrix * boneMatrix * vec4(aPositionVertex, 1);
	varVertexPosition = vec3(vertPos4) / vertPos4.w;

	// TODO auslagern
	mat4 normalMatrix = transpose(inverse(modelMatrix * boneMatrix));// * viewMatrix));

	varNormal = vec3(normalMatrix * vec4(aNormal, 0.0));
	//varNormal = vec3(projectionMatrix * viewMatrix * modelMatrix * boneMatrix * vec4(aNormal, 0.0));
	varTangent = vec3(projectionMatrix * viewMatrix * modelMatrix * boneMatrix * vec4(aTangent, 0.0));
	
	// Calculate position
	// modelViewProjectionMatrix = projection * view * model
	gl_Position = projectionMatrix * viewMatrix * modelMatrix * boneMatrix * vec4(aPositionVertex, 1);

}